[tor-commits] [tor/release-0.3.3] Make sure that the test_rust.sh script fails when a test fails

nickm at torproject.org nickm at torproject.org
Thu Jun 14 16:50:41 UTC 2018


commit 9d06c41c6e69e25a68639a09b22baa7de3299fa9
Author: Nick Mathewson <nickm at torproject.org>
Date:   Thu May 31 17:15:57 2018 -0700

    Make sure that the test_rust.sh script fails when a test fails
    
    Exit codes from find(1) seem not to be so reliable as we had hoped.
    
    Closes ticket 26258; bugfix on 0.3.3.4-alpha when we fixed #25560
---
 changes/bug26258_033  |  4 ++++
 src/test/test_rust.sh | 15 ++++++++-------
 2 files changed, 12 insertions(+), 7 deletions(-)

diff --git a/changes/bug26258_033 b/changes/bug26258_033
new file mode 100644
index 000000000..ceca38333
--- /dev/null
+++ b/changes/bug26258_033
@@ -0,0 +1,4 @@
+  o Major bugfixes (rust, testing):
+    - Fix a bug where a failure in the rust unit tests would not actually
+      cause the build to fail. Fixes bug 26258; bugfix on 0.3.3.4-alpha.
+
diff --git a/src/test/test_rust.sh b/src/test/test_rust.sh
index d87336e70..854582ec1 100755
--- a/src/test/test_rust.sh
+++ b/src/test/test_rust.sh
@@ -3,13 +3,14 @@
 
 set -e
 
-CARGO_TARGET_DIR="${abs_top_builddir:-../../..}/src/rust/target" \
+
+for cargo_toml in "${abs_top_srcdir:-../../..}"/src/rust/*/Cargo.toml; do
+    CARGO_TARGET_DIR="${abs_top_builddir:-../../..}/src/rust/target" \
     CARGO_HOME="${abs_top_builddir:-../../..}/src/rust" \
-    find "${abs_top_srcdir:-../../..}/src/rust" \
-    -mindepth 2 -maxdepth 2 \
-    -type f -name 'Cargo.toml' \
-    -exec "${CARGO:-cargo}" test --all-features ${CARGO_ONLINE-"--frozen"} \
-    --manifest-path '{}' \;
+    "${CARGO:-cargo}" test --all-features ${CARGO_ONLINE-"--frozen"} \
+    --manifest-path "$cargo_toml" || exitcode=1
+done
+
+exit $exitcode
 
-exit $?
 





More information about the tor-commits mailing list